module NotificationsCenter
  class User < Base
    KEYS = NOTIFICATION_KEYS[:user]

    def initialize(*arg)
      super
      @user = @instance.notifiable
    end

    def title
      case @key        
      when KEYS[:create]
        "#{NAME} - Création de votre compte"
      when KEYS[:new_reserved_offer]
        "Action Logement Services AL'In Logement exclusif #{@request.entity&.title}"
      else
        ''
      end
    end

    def body
      case @key        
      when KEYS[:create]
        username = @instance.datas[:username]
        "
          Nous vous confirmons votre inscription sur votre plateforme de demande de logement.\n
          Votre identifiant  : #{username}
        "
      when KEYS[:new_reserved_offer]
        str = "
        <table>
          <tbody>
            <tr>
              <td style='padding: 8px 0;'>De nouvelles offres de logement sont disponibles sur votre plateforme AL’In : ces logements sont exclusivement proposés aux salariés de votre entreprise.</td>
            </tr>
            <tr>
              <td style='padding: 8px 0;'>Consultez les offres susceptibles de vous intéresser et candidatez.</td>
            </tr>
          </tbody>
        </table>
        "
        str += "<table><tbody>"
        @instance.datas[:offer_ids].each do |offer_id|
          offer = Hermes::HousingOffer.find(offer_id)
          str += "
          <tr style='vertical-align: top'>
            <td style='padding: 8px 8px 8px 0'><img src='#{offer.picture_for_email}' width='200'/></td>
            <td style='padding: 8px;position: relative'>
              <b>#{offer.district} - #{offer.surface}m² - #{offer.typology}</b> <br/>
              #{offer.rent_with_charges} € 
              <a href='#{HERMES_CONFIG['frontend_url']}/#/fiche-logement/#{offer.id}' style='color:rgb(0, 0, 238);text-decoration: underline;position:absolute;bottom:10px;left:8px'>En savoir plus</a>
            </td>
          </tr>
          "
        end
        str += "</table></tbody>"
      else
        ''
      end
    end

    def actions
      case @key          
        when KEYS[:create]
          {
            title: 'Me connecter',
            link: '#connexion-demandeur'
          }
        when KEYS[:new_reserved_offer]
          {
            title: 'Voir les offres',
            link: '?offres'
          }
        else
          ''
      end
    end

    def header_text
      case @key
      when KEYS[:new_reserved_offer]
        "
          Des nouvelles offres sont disponibles <br/>
          Si ce message ne s'affiche pas correctement, consultez la version en ligne. 
        "
      else
        ""
      end 
    end 
  end
end